#1 - 03/20/2013 12:26 PM - Constantin Asofiei

This case was exposed by server folder compilation, in #2068 note 172:

def var i as int.

def var j as int.

form i j with frame f1.

do with frame f1:

   update i j.

end.

assign i j.

The conversion of the assign i j. statement does not link the i and j widgets with the f1 frame; instead, it puts them in the implicit frame. Interestingly, if

the update statement in the do block is removed (or if is replaced with update i j with frame f1), the code converts OK. Note that the 4GL uses frame

f1 for the assign i j., as the following test proves it:

def var i as int.

def var j as int.

form i j with frame f1.

do with frame f1:

   prompt-for i j.

end.

message i j. /* this shows the initial values before prompt-for */

assign i j.

message i j. /* this shows the entered values */

 

I'm putting here also an interesting 4GL behavior found by Ovidiu, during some view stream rpt tests. Although P2J converts it the same as 4GL does,

the behavior is interesting in terms of frame scoping:

define variable c as char.

form c with frame f1 title "explicit".

form c.

c = "bar".

display c with frame f1.

hide c in frame f1.

view c in frame f1.

display c.

hide c. /* c in frame f1 is targeted, even no explicit frame is used */

pause.

view c. /* c in frame f1 is targeted, even no explicit frame is used */
#2 - 03/21/2013 08:58 AM - Constantin Asofiei

- File ca_upd20130321a.zip added

This is a fix attempt for this issue. Looks like the solution was to explicitly set the frame name, in case the "frame referer" statement didn't explicitly

refer a frame, but a frame name was resolved for it (due to a "strong reference" frame scope).

I'm putting this through conversion regression testing.

#3 - 03/21/2013 09:45 AM - Constantin Asofiei

I'm still missing something, lots of invalid changes in MAJIC.

#4 - 03/21/2013 11:41 AM - Constantin Asofiei

- File ca_upd20130321c.zip added

This update has passed conversion regression testing. There are some changes in MAJIC, but they do not affect runtime or logic (for some reason, a

widget expression's index is changed for a frame, in the MemoProgramFList.java frame).

#5 - 03/21/2013 12:46 PM - Greg Shah

This looks good.  Check it in and distribute it.

#6 - 03/21/2013 12:53 PM - Constantin Asofiei

- Status changed from WIP to Review

Check it in and distribute it.

 

Committed to bzr revision 10308.

#7 - 03/21/2013 01:32 PM - Greg Shah

- Status changed from Review to Closed

#8 - 11/16/2016 11:06 AM - Greg Shah

- Target version changed from Milestone 4 to Conversion Support for Server Features

Files

ca_upd20130321a.zip 31.8 KB 03/21/2013 Constantin Asofiei

ca_upd20130321c.zip 31.8 KB 03/21/2013 Constantin Asofiei
